function MSNSession(client, win) {
    this.bundle = getStringBundle('chrome://msnmsgr/locale/session.properties');
    this.data = '';
    this.Contacts = new Array();
    this._CLIENT = client;
    this._SOCKET = new Socket();
    this._WINDOW = win;
    this._TRIAL = -1;
}

MSNSession.prototype.ContactsCount = function() {
    var count = 0;
    for (var i in this.Contacts) {
        if (typeof(this.Contacts[i]) == "object") {
            count++;
        }
    }
    return count;
}

MSNSession.prototype.FindContact = function(id) {
    for (var i in this.Contacts) {
        var c = this.Contacts[i];
        if (c.EMail == id)
            return c;
    }
}

MSNSession.prototype.answer = function(host, port, cki, sessionID) {
    this._SESSIONID = sessionID;
    this.__initialSend = 'ANS ' + this.trial + ' ' + this._CLIENT.passport + ' ' + cki + ' ' + sessionID + '\r\n';
    this._SOCKET.connect(host, port, this);
}

MSNSession.prototype.open = function(host, port, cki) {
    this.__initialSend = 'USR ' + this.trial + ' ' + this._CLIENT.passport + ' ' + cki + '\r\n';
    this._SOCKET.connect(host, port, this);
}

MSNSession.prototype.invite = function(contact) {
    this._SOCKET.sendData('CAL ' + this.trial + ' ' + contact + '\r\n');
}

MSNSession.prototype.exit = function() {
    this._SOCKET.sendData('OUT\r\n');
    this._SOCKET.disconnect();
}

MSNSession.prototype.send = function(msgtext) {
    var msg = 'MIME-Version: 1.0\r\n';
    msg += "Content-Type: text/plain; charset=UTF-8\r\n";
    msg += "X-MMS-IM-Format: " + this._CLIENT.MMS + "\r\n";
    msg += "\r\n";
    msg += msgtext;
    msg = "MSG " + this.trial + " N " + msg.length + "\r\n" + msg;
    this._SOCKET.sendData(msg);
}

MSNSession.prototype.sendTyping = function() {
    var msg = 'MIME-Version: 1.0\r\n';
    msg += "Content-Type: text/x-msmsgscontrol\r\n";
    msg += "TypingUser: " + this._CLIENT.passport + "\r\n";
    msg += "\r\n";
    msg = "MSG " + this.trial + " U " + msg.length + "\r\n" + msg;
    this._SOCKET.sendData(msg);
}

MSNSession.prototype.cancelInvite = function(cookie, cancelCode) {
    var msg = 'MIME-Version: 1.0\r\n';
    msg += "Content-Type: text/x-msmsgsinvite; charset=UTF-8\r\n";
    msg += "\r\n";
    msg += "Invitation-Command: CANCEL\r\n";
    msg += "Invitation-Cookie: " + cookie + "\r\n";
    msg += "Cancel-Code: " + cancelCode + "\r\n";
    msg = "MSG " + this.trial + " N " + msg.length + "\r\n" + msg;
    this._SOCKET.sendData(msg);
}

// Socket stuff
MSNSession.prototype.onConnect = function() {
    this._SOCKET.startAsyncRead();
    this._SOCKET.sendData(this.__initialSend);
    delete this.__initialSend;
}

MSNSession.prototype.onClose = function() {
    this._SOCKET = new Socket();
}

MSNSession.prototype.onDataAvailable = function(count) {
    this.data += this._SOCKET.readData(count);
    while (this.data != '') {
        var i = this.data.indexOf('\r\n');
        if (i == -1) { return }
        var data = this.data.substr(0, i);
        this.data = this.data.substr(i+2);
        _alert("<<< " + data);
        var param = data.split(" ");
        switch (param[0]) {
            case "USR":
                if (param[2] == "OK") {
                    var contact = this._WINDOW._CONTACT;
                    delete this._WINDOW._CONTACT;
                    if (contact)
                        this.invite(contact);
                }
                break;
            case "CAL":
                if (param[2] == "RINGING") {
                    this._SESSIONID = param[3];
                    this._CLIENT.registerSession(this);
                }
                break;
            case "ANS":
                this._CLIENT.registerSession(this);
                break;
            case "JOI":
                var c = this._CLIENT.Contacts['FL'][param[1]];
                if (!typeof(c) == "object") {
                    c = new MSNContact(param[1], unescape(param[2]), "NLN");
                }
                this.Contacts.push(c);
                if (this.Contacts.length > 1) {
                    var temp = this.bundle.GetStringFromName('joinMessage');
                    var msg = createNotifyNode(this._WINDOW.document, temp.replace("%S", unescape(param[2])));
                    appendAndScroll(this._WINDOW.document.getElementById('chat-panel').contentDocument, msg);
                }
                this._WINDOW.onUsersChanged();
                break;
            case "BYE":
                var c;
                for (var i in this.Contacts) {
                    if (this.Contacts[i].EMail == param[1]) {
                        c = this.Contacts[i];
                        delete this.Contacts[i];
                    }
                }
                var temp = this.bundle.GetStringFromName('leaveMessage');
                var msg = createNotifyNode(this._WINDOW.document, temp.replace("%S", c.Nickname));
                appendAndScroll(this._WINDOW.document.getElementById('chat-panel').contentDocument, msg);
                this._WINDOW.onUsersChanged();
                break;
            case "IRO":
                var c = this._CLIENT.Contacts['FL'][param[4]];
                if (typeof(c) != "object") {
                    c = new MSNContact(param[4], unescape(param[5]), "NLN");
                }
                this.Contacts.push(c);
                break;
            case "MSG":
                if (this.data.length >= param[3]) {
                    var msgdata = this.data.substr(0, param[3]);
                    this.data = this.data.substr(param[3]);
                    _alert(msgdata);
                    var parts = msgdata.split('\r\n\r\n', 2);
                    msgdata = parts[1];
                    parts = parts[0].split('\r\n');
                    var Headers = new Array();
                    for (var i in parts) {
                        var header = parts[i].split(": ");
                        Headers[header[0].toLowerCase()] = header[1];
                    }
                    if (typeof(this._WINDOW) != "object") {
                        if (Headers['content-type'].substr(0, 20) != 'text/x-msmsgscontrol') {
                            this._WINDOW = window.open('chrome://msnmsgr/content/session.xul', '_blank', 'chrome,resizable');
                            this._WINDOW._SESSION = this;
                            this._WINDOW._MSG = new Array(unescape(param[2]), param[1], Headers, msgdata)
                        }
                    } else
                        this._WINDOW.onMessageReceived(unescape(param[2]), param[1], Headers, msgdata);
                }
                else {
                    this.data = data + this.data;
                    return;
                }
                break;
            default:
                alert('Session  ' + data);
                break;
        }
    }
}

MSNSession.prototype.trial getter = function() {
    this._TRIAL++;
    return this._TRIAL;
}

function ParseHeaders(data) {
    var headers = new Array();
    var headparts = data.split('\r\n');
    for (var header in headparts) {
        header = headparts[header];
        var parts = header.split(':');
        headers[parts[0].toLowerCase()] = parts[1];
    }
    return headers;
}
